diff -r 6b3ac7e864ba binaries/data/mods/_test.sim/simulation/components/test-entityid.js
--- a/binaries/data/mods/_test.sim/simulation/components/test-entityid.js	Wed Nov 03 17:52:07 2010 +0000
+++ b/binaries/data/mods/_test.sim/simulation/components/test-entityid.js	Thu Nov 04 14:52:01 2010 +0000
@@ -2,8 +2,14 @@
 
 TestScript1A.prototype.GetX = function() {
 	// Test that .entity is readonly
-	delete this.entity;
-	this.entity = -1;
+	try {
+		delete this.entity;
+		Engine.TS_FAIL("Missed exception");
+	} catch (e) { }
+	try {
+		this.entity = -1;
+		Engine.TS_FAIL("Missed exception");
+	} catch (e) { }
 	
 	// and return the value
 	return this.entity;
diff -r 6b3ac7e864ba binaries/data/mods/_test.sim/simulation/components/test-serialize.js
--- a/binaries/data/mods/_test.sim/simulation/components/test-serialize.js	Wed Nov 03 17:52:07 2010 +0000
+++ b/binaries/data/mods/_test.sim/simulation/components/test-serialize.js	Thu Nov 04 14:52:01 2010 +0000
@@ -19,8 +19,14 @@
 
 TestScript1_entity.prototype.GetX = function() {
 	// Test that .entity is readonly
-	delete this.entity;
-	this.entity = -1;
+	try {
+		delete this.entity;
+		Engine.TS_FAIL("Missed exception");
+	} catch (e) { }
+	try {
+		this.entity = -1;
+		Engine.TS_FAIL("Missed exception");
+	} catch (e) { }
 
 	// and return the value
 	return this.entity;
diff -r 6b3ac7e864ba source/gui/CGUI.cpp
--- a/source/gui/CGUI.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/CGUI.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -326,6 +326,16 @@
 		&IGUIObject::ScriptEvent, EventName.LowerCase());
 }
 
+
+// Class needed for constructor
+static JSClass global_class = {
+	"global", JSCLASS_GLOBAL_FLAGS,
+	JS_PropertyStub, JS_PropertyStub, JS_PropertyStub, JS_PropertyStub,
+	JS_EnumerateStub, JS_ResolveStub, JS_ConvertStub, JS_FinalizeStub,
+	NULL, NULL, NULL, NULL,
+	NULL, NULL, NULL, NULL
+};
+
 //-------------------------------------------------------------------
 //  Constructor / Destructor
 //-------------------------------------------------------------------
@@ -334,10 +344,15 @@
 	m_BaseObject = new CGUIDummyObject;
 	m_BaseObject->SetGUI(this);
 
-	// Construct the parent object for all GUI JavaScript things
-	m_ScriptObject = JS_NewObject(g_ScriptingHost.getContext(), NULL, g_ScriptingHost.GetGlobalObject(), NULL);
-	debug_assert(m_ScriptObject != NULL); // How should it handle errors?
-	JS_AddRoot(g_ScriptingHost.getContext(), &m_ScriptObject);
+	// Construct the root object for all GUI JavaScript things
+	// (We need an object with no parent, so functions defined by scripts get
+	// put onto this object and not its parent. In the current version of SpiderMonkey
+	// that means it must be a global object. Then we adjust its prototype so it
+	// can still read standard properties from the context's standard global object.)
+	m_ScriptObject = JS_NewGlobalObject(g_ScriptingHost.getContext(), &global_class);
+	JS_AddObjectRoot(g_ScriptingHost.getContext(), &m_ScriptObject);
+
+	JS_SetPrototype(g_ScriptingHost.getContext(), m_ScriptObject, g_ScriptingHost.GetGlobalObject());
 }
 
 CGUI::~CGUI()
@@ -350,7 +365,7 @@
 	if (m_ScriptObject)
 	{
 		// Let it be garbage-collected
-		JS_RemoveRoot(g_ScriptingHost.getContext(), &m_ScriptObject);
+		JS_RemoveObjectRoot(g_ScriptingHost.getContext(), &m_ScriptObject);
 	}
 }
 
diff -r 6b3ac7e864ba source/gui/GUIManager.cpp
--- a/source/gui/GUIManager.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/GUIManager.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -48,22 +48,6 @@
 	return g_GUI->HandleEvent(ev);
 }
 
-CGUIManager::SGUIPage::SGUIPage()
-{
-	JS_AddNamedRoot(g_ScriptingHost.GetContext(), &initData, "SGUIPage initData");
-}
-
-CGUIManager::SGUIPage::SGUIPage(const SGUIPage& page)
-{
-	*this = page;
-	JS_AddNamedRoot(g_ScriptingHost.GetContext(), &initData, "SGUIPage initData copy");
-}
-
-CGUIManager::SGUIPage::~SGUIPage()
-{
-	JS_RemoveRoot(g_ScriptingHost.GetContext(), &initData);
-}
-
 CGUIManager::CGUIManager(ScriptInterface& scriptInterface) :
 	m_ScriptInterface(scriptInterface)
 {
@@ -90,7 +74,7 @@
 {
 	m_PageStack.push_back(SGUIPage());
 	m_PageStack.back().name = pageName;
-	m_PageStack.back().initData = initData;
+	m_PageStack.back().initData = CScriptValRooted(m_ScriptInterface.GetContext(), initData);
 	LoadPage(m_PageStack.back());
 }
 
diff -r 6b3ac7e864ba source/gui/GUIManager.h
--- a/source/gui/GUIManager.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/GUIManager.h	Thu Nov 04 14:52:01 2010 +0000
@@ -135,15 +135,11 @@
 private:
 	struct SGUIPage
 	{
-		SGUIPage();
-		SGUIPage(const SGUIPage&);
-		~SGUIPage();
-
 		CStrW name;
 		std::set<VfsPath> inputs; // for hotloading
 
 		JSContext* cx;
-		CScriptVal initData; // data to be passed to the init() function
+		CScriptValRooted initData; // data to be passed to the init() function
 
 		shared_ptr<CGUI> gui; // the actual GUI page
 	};
diff -r 6b3ac7e864ba source/gui/IGUIObject.cpp
--- a/source/gui/IGUIObject.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/IGUIObject.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -90,13 +90,13 @@
 		std::map<CStr, JSObject**>::iterator it;
 		for (it = m_ScriptHandlers.begin(); it != m_ScriptHandlers.end(); ++it)
 		{
-			JS_RemoveRoot(g_ScriptingHost.getContext(), it->second);
+			JS_RemoveObjectRoot(g_ScriptingHost.getContext(), it->second);
 			delete it->second;
 		}
 	}
 	
 	if (m_JSObject)
-		JS_RemoveRoot(g_ScriptingHost.getContext(), &m_JSObject);
+		JS_RemoveObjectRoot(g_ScriptingHost.getContext(), &m_JSObject);
 }
 
 //-------------------------------------------------------------------
@@ -488,11 +488,11 @@
 {
 	JSObject** obj = new JSObject*;
 	*obj = Function;
-	JS_AddRoot(g_ScriptingHost.getContext(), obj);
+	JS_AddObjectRoot(g_ScriptingHost.getContext(), obj);
 
 	if (m_ScriptHandlers[Action])
 	{
-		JS_RemoveRoot(g_ScriptingHost.getContext(), m_ScriptHandlers[Action]);
+		JS_RemoveObjectRoot(g_ScriptingHost.getContext(), m_ScriptHandlers[Action]);
 		delete m_ScriptHandlers[Action];
 	}
 	m_ScriptHandlers[Action] = obj;
@@ -504,10 +504,6 @@
 	if (it == m_ScriptHandlers.end())
 		return;
 
-	// PRIVATE_TO_JSVAL assumes two-byte alignment,
-	// so make sure that's always true
-	debug_assert(! ((jsval)this & JSVAL_INT));
-
 	// The IGUIObject needs to be stored inside the script's object
 	jsval guiObject = PRIVATE_TO_JSVAL(this);
 
@@ -517,9 +513,6 @@
 	
 	// TODO: why don't we use GetJSObject here?
 
-	// Prevent it from being garbage-collected before it's passed into the function
-	JS_AddRoot(g_ScriptingHost.getContext(), &jsGuiObject);
-
 	// Set up the 'mouse' parameter
 	jsval mouseParams[3];
 	mouseParams[0] = INT_TO_JSVAL(m_pGUI->m_MousePos.x);
@@ -528,9 +521,6 @@
 	JSObject* mouseObj = JS_ConstructObjectWithArguments(g_ScriptingHost.getContext(), &JSI_GUIMouse::JSI_class, m_pGUI->m_ScriptObject, NULL, 3, mouseParams);
 	debug_assert(mouseObj); // TODO: Handle errors
 
-	// Don't garbage collect the mouse
-	JS_AddRoot(g_ScriptingHost.getContext(), &mouseObj);
-
 	jsval paramData[] = { OBJECT_TO_JSVAL(mouseObj) };
 
 	jsval result;
@@ -539,10 +529,6 @@
 	{
 		JS_ReportError(g_ScriptingHost.getContext(), "Errors executing script action \"%s\"", Action.c_str());
 	}
-
-	// Allow the temporary parameters to be garbage-collected
-	JS_RemoveRoot(g_ScriptingHost.getContext(), &mouseObj);
-	JS_RemoveRoot(g_ScriptingHost.getContext(), &jsGuiObject);
 }
 
 void IGUIObject::ScriptEvent(const CStr& Action, const CScriptValRooted& Argument)
@@ -571,7 +557,7 @@
 	if (! m_JSObject)
 	{
 		m_JSObject = JS_NewObject(g_ScriptingHost.getContext(), &JSI_IGUIObject::JSI_class, NULL, NULL);
-		JS_AddRoot(g_ScriptingHost.getContext(), &m_JSObject);
+		JS_AddObjectRoot(g_ScriptingHost.getContext(), &m_JSObject);
 		JS_SetPrivate(g_ScriptingHost.getContext(), m_JSObject, this);
 	}
 	return m_JSObject;
diff -r 6b3ac7e864ba source/gui/IGUIObject.h
--- a/source/gui/IGUIObject.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/IGUIObject.h	Thu Nov 04 14:52:01 2010 +0000
@@ -145,8 +145,8 @@
 	friend class GUITooltip;
 
 	// Allow getProperty to access things like GetParent()
-	friend JSBool JSI_IGUIObject::getProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp);
-	friend JSBool JSI_IGUIObject::setProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp);
+	friend JSBool JSI_IGUIObject::getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
+	friend JSBool JSI_IGUIObject::setProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
 
 public:
 	IGUIObject();
diff -r 6b3ac7e864ba source/gui/scripting/JSInterface_GUITypes.cpp
--- a/source/gui/scripting/JSInterface_GUITypes.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/scripting/JSInterface_GUITypes.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -45,30 +45,32 @@
 
 JSFunctionSpec JSI_GUISize::JSI_methods[] = 
 {
-	{ "toString", JSI_GUISize::toString, 0, 0, 0 },
+	{ "toString", JSI_GUISize::toString, 0, 0 },
 	{ 0 }
 };
 
-JSBool JSI_GUISize::construct(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* UNUSED(rval))
+JSBool JSI_GUISize::construct(JSContext* cx, uintN argc, jsval* vp)
 {
+	JSObject* obj = JS_NewObject(cx, &JSI_GUISize::JSI_class, NULL, NULL);
+
 	if (argc == 8)
 	{
-		JS_SetProperty(cx, obj, "left",		&argv[0]);
-		JS_SetProperty(cx, obj, "top",		&argv[1]);
-		JS_SetProperty(cx, obj, "right",	&argv[2]);
-		JS_SetProperty(cx, obj, "bottom",	&argv[3]);
-		JS_SetProperty(cx, obj, "rleft",	&argv[4]);
-		JS_SetProperty(cx, obj, "rtop",		&argv[5]);
-		JS_SetProperty(cx, obj, "rright",	&argv[6]);
-		JS_SetProperty(cx, obj, "rbottom",	&argv[7]);
+		JS_SetProperty(cx, obj, "left",		&JS_ARGV(cx, vp)[0]);
+		JS_SetProperty(cx, obj, "top",		&JS_ARGV(cx, vp)[1]);
+		JS_SetProperty(cx, obj, "right",	&JS_ARGV(cx, vp)[2]);
+		JS_SetProperty(cx, obj, "bottom",	&JS_ARGV(cx, vp)[3]);
+		JS_SetProperty(cx, obj, "rleft",	&JS_ARGV(cx, vp)[4]);
+		JS_SetProperty(cx, obj, "rtop",		&JS_ARGV(cx, vp)[5]);
+		JS_SetProperty(cx, obj, "rright",	&JS_ARGV(cx, vp)[6]);
+		JS_SetProperty(cx, obj, "rbottom",	&JS_ARGV(cx, vp)[7]);
 	}
 	else if (argc == 4)
 	{
 		jsval zero = JSVAL_ZERO;
-		JS_SetProperty(cx, obj, "left",		&argv[0]);
-		JS_SetProperty(cx, obj, "top",		&argv[1]);
-		JS_SetProperty(cx, obj, "right",	&argv[2]);
-		JS_SetProperty(cx, obj, "bottom",	&argv[3]);
+		JS_SetProperty(cx, obj, "left",		&JS_ARGV(cx, vp)[0]);
+		JS_SetProperty(cx, obj, "top",		&JS_ARGV(cx, vp)[1]);
+		JS_SetProperty(cx, obj, "right",	&JS_ARGV(cx, vp)[2]);
+		JS_SetProperty(cx, obj, "bottom",	&JS_ARGV(cx, vp)[3]);
 		JS_SetProperty(cx, obj, "rleft",	&zero);
 		JS_SetProperty(cx, obj, "rtop",		&zero);
 		JS_SetProperty(cx, obj, "rright",	&zero);
@@ -87,6 +89,7 @@
 		JS_SetProperty(cx, obj, "rbottom",	&zero);
 	}
 
+	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
 	return JS_TRUE;
 }
 
@@ -99,13 +102,15 @@
 		return CStr(per)+CStr("%")+( pix == 0.0 ? CStr() : pix > 0.0 ? CStr("+")+CStr(pix) : CStr(pix) );
 }
 
-JSBool JSI_GUISize::toString(JSContext* cx, JSObject* obj, uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval)
+JSBool JSI_GUISize::toString(JSContext* cx, uintN argc, jsval* vp)
 {
+	UNUSED2(argc);
+
 	CStr buffer;
 
 	try
 	{
-#define SIDE(side) buffer += ToPercentString(g_ScriptingHost.GetObjectProperty_Double(obj, #side), g_ScriptingHost.GetObjectProperty_Double(obj, "r"#side));
+#define SIDE(side) buffer += ToPercentString(g_ScriptingHost.GetObjectProperty_Double(JS_THIS_OBJECT(cx, vp), #side), g_ScriptingHost.GetObjectProperty_Double(JS_THIS_OBJECT(cx, vp), "r"#side));
 		SIDE(left);
 		buffer += " ";
 		SIDE(top);
@@ -117,11 +122,11 @@
 	}
 	catch (PSERROR_Scripting_ConversionFailed)
 	{
-		*rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, "<Error converting value to numbers>"));
+		JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(JS_NewStringCopyZ(cx, "<Error converting value to numbers>")));
 		return JS_TRUE;
 	}
 
-	*rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer.c_str()));
+	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer.c_str())));
 	return JS_TRUE;
 }
 
@@ -149,45 +154,57 @@
 
 JSFunctionSpec JSI_GUIColor::JSI_methods[] = 
 {
-	{ "toString", JSI_GUIColor::toString, 0, 0, 0 },
+	{ "toString", JSI_GUIColor::toString, 0, 0 },
 	{ 0 }
 };
 
-JSBool JSI_GUIColor::construct(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* UNUSED(rval))
+JSBool JSI_GUIColor::construct(JSContext* cx, uintN argc, jsval* vp)
 {
+	JSObject* obj = JS_NewObject(cx, &JSI_GUIColor::JSI_class, NULL, NULL);
+
 	if (argc == 4)
 	{
-		JS_SetProperty(cx, obj, "r", &argv[0]);
-		JS_SetProperty(cx, obj, "g", &argv[1]);
-		JS_SetProperty(cx, obj, "b", &argv[2]);
-		JS_SetProperty(cx, obj, "a", &argv[3]);
+		JS_SetProperty(cx, obj, "r", &JS_ARGV(cx, vp)[0]);
+		JS_SetProperty(cx, obj, "g", &JS_ARGV(cx, vp)[1]);
+		JS_SetProperty(cx, obj, "b", &JS_ARGV(cx, vp)[2]);
+		JS_SetProperty(cx, obj, "a", &JS_ARGV(cx, vp)[3]);
 	}
 	else
 	{
 		// Nice magenta:
-		jsval r = DOUBLE_TO_JSVAL(JS_NewDouble(cx, 1.0));
-		JS_SetProperty(cx, obj, "r", &r);
-		jsval g = DOUBLE_TO_JSVAL(JS_NewDouble(cx, 0.0));
-		JS_SetProperty(cx, obj, "g", &g);
-		jsval b = DOUBLE_TO_JSVAL(JS_NewDouble(cx, 1.0));
-		JS_SetProperty(cx, obj, "b", &b);
-		jsval a = DOUBLE_TO_JSVAL(JS_NewDouble(cx, 1.0));
-		JS_SetProperty(cx, obj, "a", &a);
+		jsval c;
+		if (!JS_NewNumberValue(cx, 1.0, &c))
+			return JS_FALSE;
+		JS_SetProperty(cx, obj, "r", &c);
+		JS_SetProperty(cx, obj, "b", &c);
+		JS_SetProperty(cx, obj, "a", &c);
+		if (!JS_NewNumberValue(cx, 0.0, &c))
+			return JS_FALSE;
+		JS_SetProperty(cx, obj, "g", &c);
 	}
+
+	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
 	return JS_TRUE;
 }
 
-JSBool JSI_GUIColor::toString(JSContext* cx, JSObject* obj,
-	uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval)
+JSBool JSI_GUIColor::toString(JSContext* cx, uintN argc, jsval* vp)
 {
+	UNUSED2(argc);
+
+	jsdouble r, g, b, a;
+	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "r"), &r)) return JS_FALSE;
+	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "g"), &g)) return JS_FALSE;
+	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "b"), &b)) return JS_FALSE;
+	if (!JS_ValueToNumber(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "a"), &a)) return JS_FALSE;
+
 	char buffer[256];
 	// Convert to integers, to be compatible with the GUI's string SetSetting
 	snprintf(buffer, 256, "%d %d %d %d",
-		(int)( 255.0 * *JSVAL_TO_DOUBLE(g_ScriptingHost.GetObjectProperty(obj, "r")) ),
-		(int)( 255.0 * *JSVAL_TO_DOUBLE(g_ScriptingHost.GetObjectProperty(obj, "g")) ),
-		(int)( 255.0 * *JSVAL_TO_DOUBLE(g_ScriptingHost.GetObjectProperty(obj, "b")) ),
-		(int)( 255.0 * *JSVAL_TO_DOUBLE(g_ScriptingHost.GetObjectProperty(obj, "a")) ));
-	*rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer));
+		(int)(255.0 * r),
+		(int)(255.0 * g),
+		(int)(255.0 * b),
+		(int)(255.0 * a));
+	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer)));
 	return JS_TRUE;
 }
 
@@ -213,17 +230,19 @@
 
 JSFunctionSpec JSI_GUIMouse::JSI_methods[] = 
 {
-	{ "toString", JSI_GUIMouse::toString, 0, 0, 0 },
+	{ "toString", JSI_GUIMouse::toString, 0, 0 },
 	{ 0 }
 };
 
-JSBool JSI_GUIMouse::construct(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* UNUSED(rval))
+JSBool JSI_GUIMouse::construct(JSContext* cx, uintN argc, jsval* vp)
 {
+	JSObject* obj = JS_NewObject(cx, &JSI_GUIMouse::JSI_class, NULL, NULL);
+
 	if (argc == 3)
 	{
-		JS_SetProperty(cx, obj, "x", &argv[0]);
-		JS_SetProperty(cx, obj, "y", &argv[1]);
-		JS_SetProperty(cx, obj, "buttons", &argv[2]);
+		JS_SetProperty(cx, obj, "x", &JS_ARGV(cx, vp)[0]);
+		JS_SetProperty(cx, obj, "y", &JS_ARGV(cx, vp)[1]);
+		JS_SetProperty(cx, obj, "buttons", &JS_ARGV(cx, vp)[2]);
 	}
 	else
 	{
@@ -232,17 +251,23 @@
 		JS_SetProperty(cx, obj, "y", &zero);
 		JS_SetProperty(cx, obj, "buttons", &zero);
 	}
+
+	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
 	return JS_TRUE;
 }
 
-JSBool JSI_GUIMouse::toString(JSContext* cx, JSObject* obj, uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval)
+JSBool JSI_GUIMouse::toString(JSContext* cx, uintN argc, jsval* vp)
 {
+	UNUSED2(argc);
+
+	int32 x, y, buttons;
+	if (!JS_ValueToECMAInt32(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "x"), &x)) return JS_FALSE;
+	if (!JS_ValueToECMAInt32(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "y"), &y)) return JS_FALSE;
+	if (!JS_ValueToECMAInt32(cx, g_ScriptingHost.GetObjectProperty(JS_THIS_OBJECT(cx, vp), "buttons"), &buttons)) return JS_FALSE;
+
 	char buffer[256];
-	snprintf(buffer, 256, "%d %d %d",
-		JSVAL_TO_INT(g_ScriptingHost.GetObjectProperty(obj, "x")),
-		JSVAL_TO_INT(g_ScriptingHost.GetObjectProperty(obj, "y")),
-		JSVAL_TO_INT(g_ScriptingHost.GetObjectProperty(obj, "buttons")) );
-	*rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer));
+	snprintf(buffer, 256, "%d %d %d", x, y, buttons);
+	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer)));
 	return JS_TRUE;
 }
 
diff -r 6b3ac7e864ba source/gui/scripting/JSInterface_GUITypes.h
--- a/source/gui/scripting/JSInterface_GUITypes.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/scripting/JSInterface_GUITypes.h	Thu Nov 04 14:52:01 2010 +0000
@@ -26,8 +26,8 @@
 		extern JSClass JSI_class;				\
 		extern JSPropertySpec JSI_props[];		\
 		extern JSFunctionSpec JSI_methods[];	\
-		JSBool construct( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );	\
-		JSBool toString( JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval );	\
+		JSBool construct(JSContext* cx, uintN argc, jsval* vp);	\
+		JSBool toString(JSContext* cx, uintN argc, jsval* vp);	\
 	}
 
 GUISTDTYPE(Size)
diff -r 6b3ac7e864ba source/gui/scripting/JSInterface_IGUIObject.cpp
--- a/source/gui/scripting/JSInterface_IGUIObject.cpp	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/scripting/JSInterface_IGUIObject.cpp	Thu Nov 04 14:52:01 2010 +0000
@@ -46,15 +46,23 @@
 
 JSFunctionSpec JSI_IGUIObject::JSI_methods[] = 
 {
-	{ "toString", JSI_IGUIObject::toString, 0, 0, 0 },
-	{ "focus", JSI_IGUIObject::focus, 0, 0, 0 },
-	{ "blur", JSI_IGUIObject::blur, 0, 0, 0 },
+	{ "toString", JSI_IGUIObject::toString, 0, 0 },
+	{ "focus", JSI_IGUIObject::focus, 0, 0 },
+	{ "blur", JSI_IGUIObject::blur, 0, 0 },
 	{ 0 }
 };
 
-JSBool JSI_IGUIObject::getProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp)
+JSBool JSI_IGUIObject::getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
 {
-	CStr propName = JS_GetStringBytes(JS_ValueToString(cx, id));
+	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, obj, &JSI_IGUIObject::JSI_class, NULL);
+	if (!e)
+		return JS_FALSE;
+
+	jsval idval;
+	if (!JS_IdToValue(cx, id, &idval))
+		return JS_FALSE;
+
+	CStr propName = g_ScriptingHost.ValueToString(idval);
 
 	// Skip some things which are known to be functions rather than properties.
 	// ("constructor" *must* be here, else it'll try to GetSettingType before
@@ -69,8 +77,6 @@
 	   )
 		return JS_TRUE;
 
-	IGUIObject* e = (IGUIObject*)JS_GetPrivate(cx, obj);
-
 	// Use onWhatever to access event handlers
 	if (propName.Left(2) == "on")
 	{
@@ -143,8 +149,7 @@
 				float value;
 				GUI<float>::GetSetting(e, propName, value);
 				// Create a garbage-collectable double
-				*vp = DOUBLE_TO_JSVAL(JS_NewDouble(cx, value) );
-				break;
+				return JS_NewNumberValue(cx, value, vp);
 			}
 
 		case GUIST_CColor:
@@ -154,8 +159,9 @@
 				JSObject* obj = JS_NewObject(cx, &JSI_GUIColor::JSI_class, NULL, NULL);
 				*vp = OBJECT_TO_JSVAL(obj); // root it
 
+				jsval c;
 				// Attempt to minimise ugliness through macrosity
-				#define P(x) jsval x = DOUBLE_TO_JSVAL(JS_NewDouble(cx, colour.x)); JS_SetProperty(cx, obj, #x, &x)
+				#define P(x) if (!JS_NewNumberValue(cx, colour.x, &c)) return JS_FALSE; JS_SetProperty(cx, obj, #x, &c)
 					P(r);
 					P(g);
 					P(b);
@@ -286,10 +292,18 @@
 	}
 }
 
-JSBool JSI_IGUIObject::setProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp)
+JSBool JSI_IGUIObject::setProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
 {
-	IGUIObject* e = (IGUIObject*)JS_GetPrivate(cx, obj);
-	CStr propName = g_ScriptingHost.ValueToString(id);
+	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, obj, &JSI_IGUIObject::JSI_class, NULL);
+	if (!e)
+		return JS_FALSE;
+
+	jsval idval;
+	if (!JS_IdToValue(cx, id, &idval))
+		return JS_FALSE;
+
+	CStr propName = g_ScriptingHost.ValueToString(idval);
+
 	if (propName == "name")
 	{
 		CStr propValue = JS_GetStringBytes(JS_ValueToString(cx, *vp));
@@ -549,7 +563,7 @@
 }
 
 
-JSBool JSI_IGUIObject::construct(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* UNUSED(rval))
+JSBool JSI_IGUIObject::construct(JSContext* cx, uintN argc, jsval* vp)
 {
 	if (argc == 0)
 	{
@@ -557,12 +571,13 @@
 		return JS_FALSE;
 	}
 
-	debug_assert(argc == 1);
+	JSObject* obj = JS_NewObject(cx, &JSI_IGUIObject::JSI_class, NULL, NULL);
 
 	// Store the IGUIObject in the JS object's 'private' area
-	IGUIObject* guiObject = (IGUIObject*)JSVAL_TO_PRIVATE(argv[0]);
+	IGUIObject* guiObject = (IGUIObject*)JSVAL_TO_PRIVATE(JS_ARGV(cx, vp)[0]);
 	JS_SetPrivate(cx, obj, guiObject);
 
+	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
 	return JS_TRUE;
 }
 
@@ -571,28 +586,40 @@
 	g_ScriptingHost.DefineCustomObjectType(&JSI_class, construct, 1, JSI_props, JSI_methods, NULL, NULL);
 }
 
-JSBool JSI_IGUIObject::toString(JSContext* cx, JSObject* obj, uintN UNUSED(argc), jsval* UNUSED(argv), jsval* rval)
+JSBool JSI_IGUIObject::toString(JSContext* cx, uintN argc, jsval* vp)
 {
-	IGUIObject* e = (IGUIObject*)JS_GetPrivate( cx, obj );
+	UNUSED2(argc);
+
+	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, JS_THIS_OBJECT(cx, vp), &JSI_IGUIObject::JSI_class, NULL);
+	if (!e)
+		return JS_FALSE;
 
 	char buffer[256];
 	snprintf(buffer, 256, "[GUIObject: %s]", e->GetName().c_str());
 	buffer[255] = 0;
-	*rval = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer));
+	JS_SET_RVAL(cx, vp, STRING_TO_JSVAL(JS_NewStringCopyZ(cx, buffer)));
 	return JS_TRUE;
 }
 
-JSBool JSI_IGUIObject::focus(JSContext* cx, JSObject* obj, uintN UNUSED(argc), jsval* UNUSED(argv), jsval* UNUSED(rval))
+JSBool JSI_IGUIObject::focus(JSContext* cx, uintN argc, jsval* vp)
 {
-	IGUIObject* e = (IGUIObject*)JS_GetPrivate( cx, obj );
+	UNUSED2(argc);
+
+	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, JS_THIS_OBJECT(cx, vp), &JSI_IGUIObject::JSI_class, NULL);
+	if (!e)
+		return JS_FALSE;
 
 	e->GetGUI()->SetFocusedObject(e);
 	return JS_TRUE;
 }
 
-JSBool JSI_IGUIObject::blur(JSContext* cx, JSObject* obj, uintN UNUSED(argc), jsval* UNUSED(argv), jsval* UNUSED(rval))
+JSBool JSI_IGUIObject::blur(JSContext* cx, uintN argc, jsval* vp)
 {
-	IGUIObject* e = (IGUIObject*)JS_GetPrivate( cx, obj );
+	UNUSED2(argc);
+
+	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, JS_THIS_OBJECT(cx, vp), &JSI_IGUIObject::JSI_class, NULL);
+	if (!e)
+		return JS_FALSE;
 
 	e->GetGUI()->SetFocusedObject(NULL);
 	return JS_TRUE;
diff -r 6b3ac7e864ba source/gui/scripting/JSInterface_IGUIObject.h
--- a/source/gui/scripting/JSInterface_IGUIObject.h	Wed Nov 03 17:52:07 2010 +0000
+++ b/source/gui/scripting/JSInterface_IGUIObject.h	Thu Nov 04 14:52:01 2010 +0000
@@ -25,14 +25,12 @@
 	extern JSClass JSI_class;
 	extern JSPropertySpec JSI_props[];
 	extern JSFunctionSpec JSI_methods[];
-	JSBool addProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp);
-	JSBool delProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp);
-	JSBool getProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp);
-	JSBool setProperty(JSContext* cx, JSObject* obj, jsval id, jsval* vp);
-	JSBool construct(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval);
-	JSBool toString(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval);
-	JSBool focus(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval);
-	JSBool blur(JSContext* cx, JSObject* obj, uintN argc, jsval* argv, jsval* rval);
+	JSBool getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
+	JSBool setProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
+	JSBool construct(JSContext* cx, uintN argc, jsval* vp);
+	JSBool toString(JSContext* cx, uintN argc, jsval* vp);
+	JSBool focus(JSContext* cx, uintN argc, jsval* vp);
+	JSBool blur(JSContext* cx, uintN argc, jsval* vp);
 	void init();
 }
 
